#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[])
{
    FILE *inFile,*outFile;
    int i,d;
    int newSize,hdrBytes;
    unsigned short chksum = 0;
    unsigned char c;

    if (argc != 5)
    {
        printf("Usage: padsms input.sms output.sms newSize stripHeader\n");
        exit(1);
    }

    newSize = atoi(argv[3]);
    if (newSize < 1)
    {
        printf("newSize must be at least 1 kB\n");
        exit(1);
    }
    newSize *= 1024;
    if (newSize > 4*1024*1024)
    {
        printf("newSize must be <= 4 MB\n");
        exit(1);
    }

    hdrBytes = atoi(argv[4]);
    if (hdrBytes < 0) hdrBytes = 0;
    if (hdrBytes > newSize) hdrBytes = newSize;

    // Pad/trim file
    inFile = fopen(argv[1], "rb");
    outFile = fopen(argv[2], "wb");
    if (inFile == NULL || outFile == NULL) return 1;

    i = 0;
    while (i < newSize)
    {
        d = fgetc(inFile);
        if (d == EOF) break;
        if (hdrBytes)
            hdrBytes--;
        else
        {
            fputc(d, outFile);
            i++;
        }
    }

    fclose(inFile);

    while (i < newSize)
    {
        fputc(0, outFile);
        i++;
    }

    fclose(outFile);

    // Fix header
    inFile = fopen(argv[2], "rb+");
    if (inFile == NULL) return 1;

    for (i = 0; i < 0x7FF0; i++)
    {
        c = fgetc(inFile);
        chksum += c;
    }

    fseek(inFile, 0x7FF0, SEEK_SET);

    fputs("TMR SEGA  ", inFile);

    fputc(chksum&0xFF, inFile);
    fputc(chksum>>8, inFile);

    fputc(0, inFile);  // product code
    fputc(0, inFile);  // ...
    fputc(0, inFile);  // .. / version

    fputc(0x4C, inFile);   // 32 kB ROM / US/Eu region
                            // ( ROM size doesn't have to be the actual size. It's used to determine
                            //   how much of the ROM to checksum )

    fclose(inFile);

    return 0;
}

